<?php

	class wialon_pro {
		public $sid = "";
		public $id_user_session = "";
		
		private $dns = "";
		private $login_name = "";
		private $login_pass = "";
		private $log = "";
		
		private $debug_mode = "1";
	
		function __construct($client,$dns,$login,$pass) {
			
			if ($client == "" ) {
				$this->log = new logs("trace");
			} else {
				$this->log = new logs($client);
			}
			
			if ($dns == "") {
				$this->log->trace("Error initialize object class wialon_pro: dns=$dns, login=$login, pass=$pass");
				return;
			}
			
			$this->dns = $dns;
			$this->login_name = $login;
			$this->login_pass = $pass;				
			
			if ($this->login_name != "")
				$this->login();
		}
				
		// login
		function login() 
		{	
			if ($this->debug_mode == "1")
				$this->log->trace("Attempt login to wialon " . $this->dns . ", login=" . $this->login_name);
				
			$result_login = $this->wialon_request("core/login","{\"user\":\"" . $this->login_name . "\", \"password\":\"" . $this->login_pass . "\"}");
			if ($result_login == "error") {
				$this->log->trace("Error login to wialon " . $this->dns . ", login=" . $this->login_name);
				return;
			}
			if (isset($result_login -> {'ssid'}))
				$this->sid = $result_login -> {'ssid'};
			if (isset($result_login -> {'uid'}))
			$this->id_user_session = $result_login -> {'uid'};	
			if ($this->debug_mode == "1")
				$this->log->trace("Correct login to wialon (sid: " . $this->sid . ")");
		}
		// logout
		function logout() 
		{
			if ($this->sid == "")
				return "error";
			
			if ($this->debug_mode == "1")			
				$this->log->trace("Logout wialon (sid: " . $this->sid . ")");
			$this->wialon_request("core/logout","{}");
			$this->sid = "";
			$this->id_user_session = "";
			$this->pup_user_session = "";
		}
		// request to wialon with socket
		function wialon_request($svc,$params) 
		{
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this->log->trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			if ($this->sid != "")
				$data = "svc=" . $svc . "&ssid=" . $this->sid . "&params=" . $params . "\r\n";
			else 
				$data = "svc=" . $svc . "&params=" . $params . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->log->trace("request: " . $data);
			}
			
			$out = "POST /ajax.html HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			if ($this->debug_mode == "1") {
                        	$this->log->trace("ok write");
                        }
			stream_set_timeout($fp, 30);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			if ($this->debug_mode == "1") {
                        	$this->log->trace("ok read");
                        }			

			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
			//	$this->log->trace("answer: " . $html);
			}
			
			$json = json_decode($html);
			if (isset($json->{'error'}) && $json->{'error'} != "") {			
				if ($json->{'error'} == "1") {
					$this->login();
				}
				$this->log->trace("Errro request to Wialon (sid: " . $this->sid . ") : " . $html);
				return "error";
			}
			
			return $json;
		}
			// get units array
		function get_items($type,$flags,$from,$to)
		{
			$params = '{"spec":{"itemsType":"' . $type . '","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":' . $flags . ',"from":' . $from . ',"to": ' . $to . '}';
			$items = $this->wialon_request("core/search_items",$params);
			
			if (isset($items->{'items'}))
			      return $items -> {'items'};
			else
			      return ""; 
		}
		
		// check sid
		function check_sid()
		{
			
			$params = '{"spec":{"itemsType":"avl_unit","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":0x1,"from":0,"to":"0xffffffff"}';
			if ($this->wialon_request("core/search_items",$params) == "error")
				return "false";
			else
				return "true";
		}
		
		function get_groups() {
			$res_array = "";
			$units = $this->get_items("avl_unit",0x401);
			$groups = $this->get_items("avl_unit_group",0x9);
			if ($groups != "")
			foreach($groups as $group) {

				$name_group = $group->{'nm'};
				$id_group = $group->{'id'};
				$unit_ids = $group->{'u'};

				$info_units = "";
				
				if ($unit_ids != "")
				foreach($unit_ids as $unit_id) {
					foreach($units as $unit) {
						$id_unit = $unit->{'id'};
						if ($id_unit == $unit_id) {
							$name_unit = $unit->{'nm'};
							$pos_unit = $unit->{'pos'};
							
							$speed_unit = "";
							$sats_unit = "";
							$lat_unit = "";
							$lon_unit = "";
							$time_unit = "";
							if ($pos_unit != "") {
								$time_unit = $pos_unit->{'t'};
								$lat_unit = $pos_unit->{'y'};
								$lon_unit = $pos_unit->{'x'};
								$speed_unit = $pos_unit->{'s'};
								$sats_unit = $pos_unit->{'sc'};
							}
							
							if ($info_units != "")
								$info_units = $info_units . ",";

							$info_units = $info_units . "{\"name\":\"$name_unit\",\"id\":\"$id_unit\",\"time\":\"$time_unit\",\"lat\":\"$lat_unit\",\"lon\":\"$lon_unit\",\"speed\":\"$speed_unit\",\"sats\":\"$sats_unit\"}";
							
							
							break;
						}
					}
				}
				
				if ($res_array != "")
					$res_array = $res_array . ",";

				$res_array = $res_array . "{\"name\":\"$name_group\",\"id\":\"$id_group\",\"units\":[$info_units]}";

			}

			return $res_array;	
		}
		
	} 

?>
